# include	"CFingerPromptWindow.h"
# include	"CPlanWindow.h"
# include	"FingerEngine.h"
# include	<stringclass.h>

enum {
	kHeight	= 89,
	kWidth	= 200,
	kLeft	= 100,
	kTop	= 70,
	MSG_NULL		= 'null',
	MSG_BUTTON_HIT	= 'bttn'
};

# define	DEFAULT_BUTTON_PAD	(3)

CStaggeredWindowArranger CFingerPromptWindow::mArranger(
	BPoint( kLeft, kTop ),		// Origin
	BPoint( kWidth, kHeight ),	// Window size
	BPoint( 5, 5 ),				// Per-window offset
	4 );						// Max windows before restarting

CFingerPromptWindow::CFingerPromptWindow( )
	: CStandardWindow( mArranger.NextFrame( ), "Finger",
	B_TITLED_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE )
{
	BView*		view;
	BButton*	button;
	BRect		rect;	

	Lock( );

		// Build container view
	rect.Set( 0, 0, kWidth, kHeight );
	view = new BView( rect, "Finger Prompt", B_FOLLOW_ALL,
		B_WILL_DRAW );
	AddChild( view );
//	view->SetViewColor( 0xE0, 0xE0, 0xE0, 0x00 );

		// Build user name field
	rect.Set( 10, 9, kWidth - 10, 25 );
	mUserName = new BTextControl( rect, "User name", "User:",
		"", new BMessage( MSG_NULL ) );
	mUserName->SetDivider( 40 );
	view->AddChild( mUserName );
	mUserName->MakeFocus( );
	
		// Build host name field
	rect.Set( 10, 29, kWidth - 10, 45 );
	mHostName = new BTextControl( rect, "Host name", "Host:",
		"", new BMessage( MSG_NULL ) );
	mHostName->SetDivider( 40 );
	view->AddChild( mHostName );
	
		// Build reply button
	rect.Set( kWidth / 2, 50 + DEFAULT_BUTTON_PAD,
		kWidth - (10 + DEFAULT_BUTTON_PAD), 73 + DEFAULT_BUTTON_PAD );
	button = new BButton( rect, "DoFinger", "Go",
		new BMessage( MSG_BUTTON_HIT ) );
	view->AddChild( button );
	SetDefaultButton( button );
	
	Unlock( );
	Show( );
}	

void CFingerPromptWindow::MessageReceived( BMessage* inMessage )
{
	switch ( inMessage->what )
	{
		case MSG_NULL:
			break;
		
		case MSG_BUTTON_HIT:
			DisplayPlan( mUserName->Text( ), mHostName->Text( ) );
			Quit( );
			break;
	
		default:
			CStandardWindow::MessageReceived( inMessage );
	}
}

bool CFingerPromptWindow::FilterKeyDown( char* inChar, BView** inView )
{
		// XXX - not called in DR7?
	if ( *inView != mUserName->ChildAt(0) || *inChar != '@' )
		return TRUE;
		
	mHostName->MakeFocus( );
	return FALSE;
}
