void CPlanWindow::FetchFingerData( )
{
	ErrorCode err = noErr;
	int our_socket = -1;
	string user;
	string hostname;
	struct sockaddr_in server_addr;
	int unixstat;
	
	RETURN_ON_ERR( ParseAddress( user, hostname ) );
	
		// XXX - Some socket code apparently non-reentrant in DR7
	sTCPLock.Lock( );

	struct hostent* server_info = gethostbyname( hostname );
	RETURN_ON_NULL( server_info );

		// Build address structure
	bzero( (char*) &server_addr, sizeof(struct sockaddr_in) );
	server_addr.sin_family = AF_INET;
	server_addr.sin_port = 79;
	server_addr.sin_addr.s_addr = *((u_long*) server_info->h_addr);
	
		// Open a socket
	our_socket = socket( AF_INET, SOCK_STREAM, 0 );
	RETURN_ON_NEGATIVE( our_socket );
	
		// Connect to port
		// XXX - connecting is non-reentrant in DR7
	unixstat = connect( our_socket, (sockaddr*) &server_addr,
		sizeof(struct sockaddr_in) );
	RETURN_ON_NEGATIVE( unixstat );

	sTCPLock.Unlock( );
	
		// Send user name (if applicable) and command terminator
	static const char crlf[] = { 13, 10 };
	RETURN_ON_NEGATIVE( send( our_socket, (const char*) (user + crlf),
		user.length( ) + 2, 0 ) );

		// Receive server response
		// XXX - The socket implementation is seriously broken.
		// So is this code.
	while ( TRUE )
	{
		char buffer[BUFFER_SIZE];
		int count = recv( our_socket, buffer, BUFFER_SIZE, 0 );

			// XXX - Should use:
//		if ( count < 0 && errno == ENOTCONN )
//			break;
//		RETURN_ON( count < 0, genericUnixErr );

			// Better, but still imperfect
		if ( count <= 0 )
			break;

			// Worst alternative, but fast
//		RETURN_ON( count <= 0, genericUnixErr );

		mPlanView->Insert( buffer, count );	 
	}
	
		// Strip extra carriage returns
	const char* text = mPlanView->Text( );
	for ( int i = mPlanView->TextLength( ) - 1; i >= 0; i-- )
	{
		if ( text[i] == '\r' )
		{
			mPlanView->Select( i, i + 1 );
			mPlanView->Delete( );
		}
	}		
	
	UpdateDatabase( );
	RecalculateWindowSize( );
	Show( );

clean_up:
	if ( our_socket != -1 )
		closesocket( our_socket );

		// XXX - Release our TCP lock if we haven't already!
	if ( sTCPLock.LockOwner( ) == find_thread( NULL ) )
		sTCPLock.Unlock( );

	if ( err )
	{
		ReportError( err, "Could not finger <" + mAddress + ">." );
		Quit( );
	}
}
